hdu 2955 Robberies 01背包 变态

来源:互联网 发布:阿扎姆号游艇数据 编辑:程序博客网 时间:2024/05/16 11:52

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 19286    Accepted Submission(s): 7123


Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input
30.04 31 0.022 0.033 0.050.06 32 0.032 0.033 0.050.10 31 0.032 0.023 0.05
 

Sample Output
246
 

 题目大意:有一个小偷要偷银行的钱,可是他偷没家银行总是有一定的概率被抓,现在给了你一个概率P,只要他被抓的概率乘积不大与P,他就是安全的。问你在他安全的情况下,他最多可以偷多少钱。

           以下是这题的主要思路:
   做这道题是,错误的认为题目所给的浮点型的数据都是精确到小数点后两位,然后把概率放大100倍,转换成为熟悉的01背包。。经测试题目的数据可能达到0.00001,甚至比0.00001还小,

于是转成以所有银行的总资产为背包容量V。(sum)。求最大的逃跑概率。。

注意:题目给我们的是被抓的概率,,而我们要求最大的逃跑率,需要去被抓的概率pi的补 ,即1-pi

只有逃跑率才会等于各个逃跑率之积,被抓的概率不会等于各个被抓的概率之积,

状态转移方程:dp[j] = max ( dp[j], dp[j-cost[i]] * weight[i])..



Problem : 2955 ( Robberies )     Judge Status : Accepted
RunId : 17099696    Language : G++    Author : 1136242673
Code Render Status : Rendered By HDOJ G++ Code Render Version 0.01 Beta
#include<iostream>#include<algorithm>#include<cstdio>#include<cstring>#include<cmath>#include<queue>#include<cctype>#include <map>#include<stdio.h>#define max(a,b)(a>b?a:b)#define min(a,b)(a<b?a:b)#define INF 0x3f3f3f3ftypedef long long ll;using namespace std;#define N 110double p[N];int m[N];double dp[N*N];int main(){    int T,i,j,n,sum;    double P;    scanf("%d",&T);    while(T--)    {        scanf("%lf%d",&P,&n);        P=1-P;        sum=0;        for(i=1;i<=n;i++)        {            scanf("%d%lf",&m[i],&p[i]);            p[i]=1-p[i];            sum=sum+m[i];        }         memset(dp,0,sizeof(dp));         dp[0]=1;  ///抢劫的金额为0时,肯定是安全的,所以d[0]=1;其他金额初始为最危险的所以概率全为0;         for(i=1;i<=n;i++)         {             for(j=sum;j>=m[i];j--)                dp[j]=max(dp[j],dp[j-m[i]]*p[i]);         }         for(i=sum;i>=0;i--)         {             if(dp[i]-P>0.000000001)  ///注意精度~~~             {                 printf("%d\n",i);                 break;             }         }    }    return 0;}

Problem : 2955 ( Robberies )     Judge Status : Accepted
RunId : 17099696    Language : G++    Author : 1136242673
Code Render Status : Rendered By HDOJ G++ Code Render Version 0.01 Beta
#include<iostream>#include<algorithm>#include<cstdio>#include<cstring>#include<cmath>#include<queue>#include<cctype>#include <map>#include<stdio.h>#define max(a,b)(a>b?a:b)#define min(a,b)(a<b?a:b)#define INF 0x3f3f3f3ftypedef long long ll;using namespace std;#define N 110double p[N];int m[N];double dp[N*N];int main(){    int T,i,j,n,sum;    double P;    scanf("%d",&T);    while(T--)    {        scanf("%lf%d",&P,&n);        P=1-P;        sum=0;        for(i=1;i<=n;i++)        {            scanf("%d%lf",&m[i],&p[i]);            p[i]=1-p[i];            sum=sum+m[i];        }         memset(dp,0,sizeof(dp));         dp[0]=1;  ///抢劫的金额为0时,肯定是安全的,所以d[0]=1;其他金额初始为最危险的所以概率全为0;         for(i=1;i<=n;i++)         {             for(j=sum;j>=m[i];j--)                dp[j]=max(dp[j],dp[j-m[i]]*p[i]);         }         for(i=sum;i>=0;i--)         {             if(dp[i]-P>0.000000001)  ///注意精度~~~             {                 printf("%d\n",i);                 break;             }         }    }    return 0;}
0 0
原创粉丝点击